package com.faraphel.tasks_valider.database.dao

import androidx.room.Dao
import androidx.room.Query
import com.faraphel.tasks_valider.database.dao.base.BaseCronDao
import com.faraphel.tasks_valider.database.dao.base.BaseSessionDao
import com.faraphel.tasks_valider.database.dao.base.BaseTaskDao
import com.faraphel.tasks_valider.database.entities.RelationPersonSessionSubjectEntity


@Dao
interface RelationPersonSessionSubjectDao : BaseTaskDao<RelationPersonSessionSubjectEntity> {
    @Query("SELECT * FROM ${RelationPersonSessionSubjectEntity.TABLE_NAME}")
    override fun getAll(): List<RelationPersonSessionSubjectEntity>

    @Query(
        "SELECT * FROM ${RelationPersonSessionSubjectEntity.TABLE_NAME} " +
        "WHERE session_id = :sessionId"
    )
    override fun getAllBySession(sessionId: Long): List<RelationPersonSessionSubjectEntity>

    /**
     * Get the object from its identifiers
     */
    @Query(
        "SELECT * FROM ${RelationPersonSessionSubjectEntity.TABLE_NAME} " +
        "WHERE student_id = :studentId " +
        "AND session_id = :sessionId " +
        "AND subject_id = :subjectId"
    )
    fun getById(studentId: Long, sessionId: Long, subjectId: Long): RelationPersonSessionSubjectEntity?
}